import {StyleSheet} from 'react-native';
import {createSpaceStyles} from '../utils/styles';
import {BORDER_RADIUS} from '../config/Spaces';

export const roundedStylesType = {
  rounded: 'borderRadius',
  'rounded-tl': 'borderTopLeftRadius',
  'rounded-tr': 'borderTopRightRadius',
  'rounded-bl': 'borderBottomLeftRadius',
  'rounded-br': 'borderBottomRightRadius',
  'rounded-t': 'borderTopLeftRadius borderTopRightRadius',
  'rounded-b': 'borderBottomLeftRadius borderBottomRightRadius',
  'rounded-l': 'borderTopLeftRadius borderBottomLeftRadius',
  'rounded-r': 'borderTopRightRadius borderBottomRightRadius',
};

const borderWidthStyle = StyleSheet.create({
  'border-0': {borderWidth: 0},
  'border-t-0': {borderTopWidth: 0},
  'border-l-0': {borderLeftWidth: 0},
  'border-b-0': {borderBottomWidth: 0},
  'border-r-0': {borderRightWidth: 0},
  'border-x-0': {borderLeftWidth: 0, borderRightWidth: 0},
  'border-y-0': {borderTopWidth: 0, borderBottomWidth: 0},
  border: {borderWidth: 1},
  'border-t': {borderTopWidth: 1},
  'border-l': {borderLeftWidth: 1},
  'border-b': {borderBottomWidth: 1},
  'border-r': {borderRightWidth: 1},
  'border-x': {borderLeftWidth: 1, borderRightWidth: 1},
  'border-y': {borderTopWidth: 1, borderBottomWidth: 1},
  'border-2': {borderWidth: 2},
  'border-t-2': {borderTopWidth: 2},
  'border-l-2': {borderLeftWidth: 2},
  'border-b-2': {borderBottomWidth: 2},
  'border-r-2': {borderRightWidth: 2},
  'border-x-2': {borderLeftWidth: 2, borderRightWidth: 2},
  'border-y-2': {borderTopWidth: 2, borderBottomWidth: 2},
  'border-3': {borderWidth: 3},
  'border-t-3': {borderTopWidth: 3},
  'border-l-3': {borderLeftWidth: 3},
  'border-b-3': {borderBottomWidth: 3},
  'border-r-3': {borderRightWidth: 3},
  'border-x-3': {borderLeftWidth: 3, borderRightWidth: 3},
  'border-y-3': {borderTopWidth: 3, borderBottomWidth: 3},
  'border-4': {borderWidth: 4},
  'border-t-4': {borderTopWidth: 4},
  'border-l-4': {borderLeftWidth: 4},
  'border-b-4': {borderBottomWidth: 4},
  'border-r-4': {borderRightWidth: 4},
  'border-x-4': {borderLeftWidth: 4, borderRightWidth: 4},
  'border-y-4': {borderTopWidth: 4, borderBottomWidth: 4},
  'border-5': {borderWidth: 5},
  'border-t-5': {borderTopWidth: 5},
  'border-l-5': {borderLeftWidth: 5},
  'border-b-5': {borderBottomWidth: 5},
  'border-r-5': {borderRightWidth: 5},
  'border-x-5': {borderLeftWidth: 5, borderRightWidth: 5},
  'border-y-5': {borderTopWidth: 5, borderBottomWidth: 5},
  'border-6': {borderWidth: 6},
  'border-t-6': {borderTopWidth: 6},
  'border-l-6': {borderLeftWidth: 6},
  'border-b-6': {borderBottomWidth: 6},
  'border-r-6': {borderRightWidth: 6},
  'border-x-6': {borderLeftWidth: 6, borderRightWidth: 6},
  'border-y-6': {borderTopWidth: 6, borderBottomWidth: 6},
  'border-8': {borderWidth: 8},
  'border-t-8': {borderTopWidth: 8},
  'border-l-8': {borderLeftWidth: 8},
  'border-b-8': {borderBottomWidth: 8},
  'border-r-8': {borderRightWidth: 8},
  'border-x-8': {borderLeftWidth: 8, borderRightWidth: 8},
  'border-y-8': {borderTopWidth: 8, borderBottomWidth: 8},
});

const roundedStyles = StyleSheet.create(
  createSpaceStyles(BORDER_RADIUS, roundedStylesType),
);

export const classBorderStyles = {
  'border-dashed': {borderStyle: 'dashed'},
  'border-dotted': {borderStyle: 'dotted'},
  'border-solid': {borderStyle: 'solid'},
  ...borderWidthStyle,
  ...roundedStyles,
};
